{ KEYWORDS: TODO,VERSION }
{ VERSION: 1.6 }
{ 1.6 / 26.10.2005
  - opraveno: OSFileSystem.GetTempFileName() blbe pouzila priponu zacinajici na tecku
  1.5 / 26.3.2005
  - OSFileSystem pouziva mapovani souboru ( pro rozumne velke soubory by to
    melo byt zrychleni )
  1.4 / 20.1.2004
  - nova vlastnost TFileSystem.Capabilities vraci bitovou kombinaci flg..
  1.3 / 4.1.2004
  - oprava nejake divne chyby s ExpandFileName('c:\test\..')
  - nova vlastnost TFileSystem.Guard:TComponent umoznuje pripojit hlidaci komponentu.
    TFileSystem ji sam nakonec zrusi. jelikoz je to komponenta, muzou se na ni navesit
    dalsi komponenty a ona bude hlidat jejich komunikace
  1.2 / 6.6.2003
  - oprava OSFileSystem.FileExists - na Win2000 je nejaky zvlastni mechanismus
    pro ignorovani neplatnych casti souborove cesty (urcite kusy s .. se preskakuji).
    fce ExpandFileName tuto logiku nezna, takze to pak spolu nehraje
  1.1 / 12.3.2003
  - oprava OSFileSystem.ExpandFileName pro jmena obsahujici ..
  1.0
  - nova metoda FindGetProperties()
  - nova metoda FileGetProperties()
  - nova metoda TFileSystem.Age
  0.9.3
  - fce OSFileSystem.GetTempFileName preskakuje vyrobene adresare
  0.9.2
  - OSFileSystem ignoruje readonly atribut pri zakladani a mazani
  0.9.1
  - kompatibilni s D5
  0.9
  - opraveno chovani OSFileSystem.ExpandFileName pro ''
  0.8
  - opravena porucha ve fci OSFileSystem.ExpandFileName pro Win9x. Nova verze
    provadi preklad jmena souboru na dlouhy ekvivalent.
  0.7
  - opravena fce ExpandFileName, ktera chybne prevadela jmena souboru, ktere maji
    jenom priponu (prazdne jmeno)
  0.6
  - nova metoda TFileSystem.CreateFileMapping
  0.5
  - GetTempFileName('\')   -> docasny adresar
    GetTempFileName('')    -> docasny soubor
    GetTempFileName('bbb') -> docasny soubor s priponou 'bbb'

    tahle konvence plati pro OSFileSystem. ostatni fileSystem-y by ji mely respektovat.
  0.4
  - rozsireni o obal DoSetCurrentDir,DoRemoveDir
}
{ Pro presmerovani souborovych operaci do globalniho TFileSystem-u staci pouzit tuhle
  unitu jako posledni v seznamu unit - rozhodne az po SysUtils a Classes, a prekompilovat
  ze zdrojaku }
unit fileSys;

interface
uses SysUtils, Classes;

const
  flgReserved1Hint = 1 shl 0; // vraci pocet polozek pro FindFirst()
type
  TSearchRec = SysUtils.TSearchRec;

  TFileSystem = class;
  TFileMapping = class
  public
    source, target: record
      fileSystem: TFileSystem;
      fileName: string
    end
  end;

  TFileSystem = class
  protected
    useCount: integer;
    destructor Destroy; override;
  protected
    function DoSetCurrentDir(const Dir: string): boolean; virtual;
    function DoRemoveDir(const Dir: string): boolean; virtual;
  public
    Data: pointer;
    Guard: TComponent;
  public
    procedure Use; virtual;
    procedure Release; virtual;
  public
    function CreateFileMapping(const FileName: string; targetFileSystem: TFileSystem): TFileMapping; virtual;
    { GetFileStream     -  This is the core of the file system.  The file system
                           must return an instance of a TStream for reading/
                           writing according to the Mode (see Classes.pas for
                           mode values).}
    function GetFileStream(const FileName: string; Mode: Integer): TStream; virtual; abstract;
    { RenameFile renames the file given by OldName to the name given by NewName.
      The return value is True if the file was successfully renamed, or False if
      an error occurred. }
    function RenameFile(const OldName, NewName: string): Boolean; virtual; abstract;
    { DeleteFile deletes the file given by FileName. The return value is True if
      the file was successfully deleted, or False if an error occurred. }
    function DeleteFile(const FileName: string): Boolean; virtual;
    { FileExists returns a boolean value that indicates whether the specified
      file exists. }
    function FileExists(const FileName: string): Boolean; virtual;
    { DirectoryExists returns a boolean value that indicates whether the specified
      directory exists. }
    function DirectoryExists(const Dir: string): Boolean; virtual;
    { GetTempFileName   -  Returns a Temporary file name. Ext can be:
      - empty string - returned file's extension is not specified
      - '\'          - returned file name is a folder name
      - extension    - returned file name has requested extension (e.g. 'WRL' )
    }
    function GetTempFileName(const Ext: string): string; virtual; abstract;
    { GetBackupFileName -  Returns a backup file name based on the name given.
                           By convention, the extension is shifted one character
                           to the right and a tilde '~' character is inserted.
                           (eg unit1.pas -> unit1.~pa). }
    function GetBackupFileName(const FileName: string): string; virtual;

    { FindFirst searches the directory given by Path for the first entry that
      matches the filename given by Path and the attributes given by Attr. The
      result is returned in the search record given by SearchRec. The return
      value is zero if the function was successful. Otherwise the return value
      is a Windows error code. FindFirst is typically used in conjunction with
      FindNext and FindClose as follows:

        Result := FindFirst(Path, Attr, SearchRec);
        while Result = 0 do
        begin
          ProcessSearchRec(SearchRec);
          Result := FindNext(SearchRec);
        end;
        FindClose(SearchRec);

      where ProcessSearchRec represents user-defined code that processes the
      information in a search record. }
    function FindFirst(const Path: string; Attr: Integer; var F: TSearchRec): Integer; virtual;
    { FindNext returs the next entry that matches the name and attributes
      specified in a previous call to FindFirst. The search record must be one
      that was passed to FindFirst. The return value is zero if the function was
      successful. Otherwise the return value is a Windows error code. }
    function FindNext(var F: TSearchRec): Integer; virtual; abstract;
    { FindClose terminates a FindFirst/FindNext sequence. FindClose does nothing
      in the 16-bit version of Windows, but is required in the 32-bit version,
      so for maximum portability every FindFirst/FindNext sequence should end
      with a call to FindClose. }
    procedure FindClose(var F: TSearchRec); virtual;

    function FindGetProperties(var F: TSearchRec): string; virtual;

    function FileGetProperties(const fileName: string): string; virtual;

    { FileGetAttr returns the file attributes of the file given by FileName. The
      attributes can be examined by AND-ing with the faXXXX constants defined
      above. A return value of -1 indicates that an error occurred. }
    function FileGetAttr(const FileName: string): Integer; virtual;
    { FileSetAttr sets the file attributes of the file given by FileName to the
      value given by Attr. The attribute value is formed by OR-ing the
      appropriate faXXXX constants. The return value is zero if the function was
      successful. Otherwise the return value is a Windows error code. }
    function FileSetAttr(const FileName: string; Attr: Integer): Integer; virtual;
    { FileAge returns the date-and-time stamp of the specified file. The return
      value can be converted to a TDateTime value using the FileDateToDateTime
      function. The return value is -1 if the file does not exist. }
    function FileAge(const FileName: string): Integer; virtual;
    { FileSetDate sets the DOS date-and-time stamp of the file given by FileName
      to the value given by Age. The DateTimeToFileDate function can be used to
      convert a TDateTime value to a DOS date-and-time stamp. The return value
      is zero if the function was successful. Otherwise the return value is a
      Windows error code. }
    function FileSetDate(const FileName: string; Age: integer): Integer; virtual;

    { GetCurrentDir returns the current directory. }
    function GetCurrentDir: string; virtual;
    { SetCurrentDir sets the current directory. The return value is True if
      the current directory was successfully changed, or False if an error
      occurred. }
    function SetCurrentDir(const Dir: string): Boolean; virtual;
    { CreateDir creates a new directory. The return value is True if a new
      directory was successfully created, or False if an error occurred. }
    function CreateDir(const Dir: string): Boolean; virtual;
    { RemoveDir deletes an existing empty directory. The return value is
      True if the directory was successfully deleted, or False if an error
      occurred. }
    function RemoveDir(const Dir: string): Boolean; virtual;

    { ExpandFileName expands the given filename to a fully qualified filename.
      The resulting string consists of a drive letter, a colon, a root relative
      directory path, and a filename. Embedded '.' and '..' directory references
      are removed. }
    function ExpandFileName(const FileName: string): string; virtual;
  public
    function Age: integer; virtual;
    function Capabilities: integer; virtual;
  end;

  { stream, ktery pouziva aktualne nastaveny TFileSystem. pro snazsi pouziti se jmenuje stejne jako ten,
    ktery je implementovany v Classes a ktery jde pres WIN32 API }
  TFileStream = class(TStream)
  private
    InternalStream: TStream;
  public
    constructor Create(const FileName: string; Mode: Word);
    destructor Destroy; override;
    procedure SetSize(NewSize: Longint); override;
    function Read(var Buffer; Count: Longint): Longint; override;
    function Write(const Buffer; Count: Longint): Longint; override;
    function Seek(Offset: Longint; Origin: Word): Longint; override;
  end;

function GetFileStream(const FileName: string; Mode: Integer): TStream;
function RenameFile(const OldName, NewName: string): Boolean;
function DeleteFile(const FileName: string): Boolean;
function FileExists(const FileName: string): Boolean;
function DirectoryExists(const Dir: string): boolean;
function GetTempFileName(const Ext: string): string;
function GetBackupFileName(const FileName: string): string;
function FindFirst(const Path: string; Attr: Integer; var F: TSearchRec): Integer;
function FindNext(var F: TSearchRec): Integer;
procedure FindClose(var F: TSearchRec);
function FileGetAttr(const FileName: string): Integer;
function FileSetAttr(const FileName: string; Attr: Integer): Integer;
function FileAge(const FileName: string): Integer;
function FileSetDate(const FileName: string; Age: integer): Integer;
function GetCurrentDir: string;
function SetCurrentDir(const Dir: string): Boolean;
function CreateDir(const Dir: string): Boolean;
function RemoveDir(const Dir: string): Boolean;
function ExpandFileName(const FileName: string): string;

var
  { mapuje se na souborovy system WIN32, resp. na jeho ekvivalenty v SysUtils }
  OSFileSystem: TFileSystem;

  { aktualne zapojeny doporuceny globalni souborovy system }
function defaultFileSystem: TFileSystem;
{ meni hodnotu defaultFileSystem }
function SetDefaultFileSystem(AFileSystem: TFileSystem): TFileSystem;

const
  { File open modes }

  fmOpenRead = SysUtils.fmOpenRead;
  fmOpenWrite = SysUtils.fmOpenWrite;
  fmOpenReadWrite = SysUtils.fmOpenReadWrite;
  fmShareCompat = SysUtils.fmShareCompat;
  fmShareExclusive = SysUtils.fmShareExclusive;
  fmShareDenyWrite = SysUtils.fmShareDenyWrite;
  fmShareDenyRead = SysUtils.fmShareDenyRead;
  fmShareDenyNone = SysUtils.fmShareDenyNone;

  { File attribute constants }

  faReadOnly = SysUtils.faReadOnly;
  faHidden = SysUtils.faHidden;
  faSysFile = SysUtils.faSysFile;
  faVolumeID = SysUtils.faVolumeID;
  faDirectory = SysUtils.faDirectory;
  faArchive = SysUtils.faArchive;
  faAnyFile = SysUtils.faAnyFile;

  InvalidFileName = #1;

implementation
{ $DEFINE LINKSWITCHES}
{$IFDEF LINKSWITCHES}
{$I SWITCHES.INC}
{$ENDIF}

uses Windows{$IFDEF TIMERS_ON}, Timers{$ENDIF};
var
  fs: TFileSystem;

procedure TFileSystem.Use;
begin
  inc(useCount);
{$IFDEF TIMERS_ON}Timers.LogFmt('%s.FS.Use(%d)', [ClassName, useCount]){$ENDIF}
end;

procedure TFileSystem.Release;
begin
{$IFDEF TIMERS_ON}Timers.LogFmt('%s.FS.Release(%d)', [ClassName, useCount]);
{$ENDIF}
  dec(useCount);
  if useCount <= 0 then
    Destroy
end;

destructor TFileSystem.Destroy;
begin
  Guard.Free;
  inherited;
  if fs = Self then fs := OSFileSystem;
  if OSFileSystem = Self then begin
    if fs = Self then fs := nil;
    OSFileSystem := nil
  end
end;

function TFileSystem.Age;
begin
  Result := -1
end;

function TFileSystem.Capabilities;
begin
  Result := 0
end;

function TFileSystem.FileExists;
begin
  Result := FileAge(FileName) <> -1;
end;

function TFileSystem.GetBackupFileName;
var
  ext: string;
begin
  ext := ExtractFileExt(FileName);
  if ext = '' then
    ext := '.~'
  else begin
    Delete(ext, 2, 1);
    Insert('~', ext, 2)
  end;
  Result := ChangeFileExt(FileName, ext)
end;

function TFileSystem.FileGetAttr;
var
  search: TSearchRec;
begin
  if FindFirst(FileName, faAnyFile, search) = 0 then
    Result := search.Attr
  else
    Result := -1;
  FindClose(search)
end;

function TFileSystem.DirectoryExists;
var
  Attr: integer;
begin
  Attr := FileGetAttr(Dir);
  Result := (Attr <> -1) and ((Attr and faDirectory) <> 0)
end;

function TFileSystem.FileAge;
var
  search: TSearchRec;
begin
  if FindFirst(FileName, faAnyFile, search) = 0 then begin
    Result := search.Time
  end
  else
    Result := -1;
  FindClose(search)
end;

function TFileSystem.DeleteFile;
begin
  Result := false
end;

function TFileSystem.GetCurrentDir;
begin
  Result := ''
end;

function TFileSystem.SetCurrentDir;
var
  newDir: string;
begin
  newDir := ExpandFileName(Dir);
  if newDir = InvalidFileName then begin
    Result := false;
    exit
  end;
  if (length(newDir) > 0) and (newDir <> ExtractFileDrive(newDir) + '\') and (newDir[length(newDir)] = '\') then SetLength(newDir, length(newDir) - 1);

  Result := DirectoryExists(newDir);
  if Result then
    Result := DoSetCurrentDir(newDir)
end;

function TFileSystem.DoSetCurrentDir;
begin
  Result := false
end;

function TFileSystem.DoRemoveDir;
begin
  Result := false
end;

function TFileSystem.CreateDir;
begin
  Result := false
end;

function TFileSystem.RemoveDir;
var
  search: TSearchRec;
var
  fname: string;
var
  found: integer;
var
  empty: boolean;
begin
  fname := ExpandFileName(Dir);
  empty := true;
  found := FindFirst(fname + '\*.*', faAnyFile, search);
  if found <> 0 then empty := false;
  while found = 0 do begin
    if (search.Attr and faDirectory) = faDirectory then begin
      if search.Name[1] <> '.' then begin
        empty := false;
        break
      end
    end
    else begin
      empty := false;
      break
    end;
    found := FindNext(search)
  end;
  FindClose(search);
  if empty then
    Result := DoRemoveDir(fname)
  else
    Result := false
end;

function TFileSystem.FindFirst;
begin
  Result := -1
end;

procedure TFileSystem.FindClose;
begin
end;

function TFileSystem.FileGetProperties;
var
  search: TSearchRec;
begin
  if FindFirst(fileName, faAnyFile, search) = 0 then
    Result := FindGetProperties(search)
  else
    Result := '';
  FindClose(search)
end;

function TFileSystem.FindGetProperties;
begin
  Result := ''
end;

function TFileSystem.FileSetAttr;
begin
  Result := -1
end;

function TFileSystem.FileSetDate;
begin
  Result := -1
end;

function TFileSystem.ExpandFileName;
var
  i, j: integer;
begin
  if ExtractFileDrive(FileName) = '' then begin
    Result := GetCurrentDir;
    if (Copy(Result, length(Result), 1) <> '\') and (Result <> '') then
      Result := Result + '\' + FileName
    else
      Result := Result + FileName
  end
  else
    Result := FileName;
  { shorten back steps }
  while true do begin
    i := Pos('\..', Result);
    if i = 0 then break;
    j := i - 1;
    while (j > 0) and (Result[j] <> '\') do
      dec(j);
    Delete(Result, j + 1, i - j - 1 + 3);
    if Result = '' then begin
      Result := InvalidFileName;
      exit
    end;
    if Length(Result) <= j then break;
    case Result[j + 1] of
      '\': Delete(Result, j + 1, 1);
      '.': Insert('.', Result, j + 1)
    end
  end;
  { cut out simple dots }
  while true do begin
    i := Pos('\.', Result);
    { now we cut only if there is no follower, or '\' follows }
    if (i = 0) or not ((i + 1 = length(Result)) or (Result[i + 2] = '\')) then break;
    Delete(Result, i, 2);
  end
end;

function TFileSystem.CreateFileMapping(const FileName: string; targetFileSystem: TFileSystem): TFileMapping;
begin
  Result := nil
end;

type
  TOSFileSystem = class(TFileSystem)
  public
    procedure Release; override;
  public
    function CreateFileMapping(const FileName: string; targetFileSystem: TFileSystem): TFileMapping; override;
    function GetFileStream(const FileName: string; Mode: Integer): TStream; override;
    function FileAge(const FileName: string): Longint; override;
    function RenameFile(const OldName, NewName: string): Boolean; override;
    function DeleteFile(const FileName: string): Boolean; override;
    function FileExists(const FileName: string): Boolean; override;
    function GetTempFileName(const Ext: string): string; override;

    function FindFirst(const Path: string; Attr: Integer; var F: TSearchRec): Integer; override;
    function FindNext(var F: TSearchRec): Integer; override;
    procedure FindClose(var F: TSearchRec); override;

    function FileSetDate(const FileName: string; Age: integer): Integer; override;
    function FileSetAttr(const FileName: string; Attr: Integer): Integer; override;

    function GetCurrentDir: string; override;
    function SetCurrentDir(const Dir: string): Boolean; override;
    function CreateDir(const Dir: string): Boolean; override;
    function RemoveDir(const Dir: string): Boolean; override;

    function ExpandFileName(const FileName: string): string; override;
  public
    function Age: integer; override;
  end;

function SetDefaultFileSystem;
begin
  Result := fs;
  if Result = AFileSystem then exit;
  fs := AFileSystem;
  if Assigned(fs) then fs.Use;
  if Assigned(Result) then
    Result.Release
end;

function defaultFileSystem;
begin
  Result := fs
end;

function GetFileStream;
begin
  Result := fs.GetFileStream(FileName, Mode)
end;

function FileAge;
begin
  Result := fs.FileAge(FileName)
end;

function RenameFile;
begin
  Result := fs.RenameFile(OldName, NewName)
end;

function DeleteFile;
begin
  Result := fs.DeleteFile(FileName)
end;

function FileExists;
begin
  Result := fs.FileExists(FileName)
end;

function DirectoryExists;
begin
  Result := fs.DirectoryExists(Dir)
end;

function GetTempFileName;
begin
  Result := fs.GetTempFileName(Ext)
end;

function GetBackupFileName;
begin
  Result := fs.GetBackupFileName(FileName)
end;

function FindFirst;
begin
  Result := fs.FindFirst(Path, Attr, F)
end;

function FindNext;
begin
  Result := fs.FindNext(F)
end;

procedure FindClose;
begin
  fs.FindClose(F)
end;

function FileGetAttr;
begin
  Result := fs.FileGetAttr(FileName)
end;

function FileSetAttr;
begin
  Result := fs.FileSetAttr(FileName, Attr)
end;

function FileSetDate;
begin
  Result := fs.FileSetDate(FileName, Age)
end;

function GetCurrentDir;
begin
  Result := fs.GetCurrentDir
end;

function SetCurrentDir;
begin
  Result := fs.SetCurrentDir(Dir)
end;

function CreateDir;
begin
  Result := fs.CreateDir(Dir)
end;

function RemoveDir;
begin
  Result := fs.RemoveDir(Dir)
end;

function ExpandFileName;
begin
  Result := fs.ExpandFileName(FileName)
end;

constructor TFileStream.Create(const FileName: string; Mode: Word);
begin
  InternalStream := GetFileStream(FileName, Mode)
end;

destructor TFileStream.Destroy;
begin
  InternalStream.Free;
  inherited
end;

procedure TFileStream.SetSize(NewSize: Longint);
begin
  InternalStream.Size := NewSize
end;

function TFileStream.Read(var Buffer; Count: Longint): Longint;
begin
  Result := InternalStream.Read(Buffer, Count)
end;

function TFileStream.Write(const Buffer; Count: Longint): Longint;
begin
  Result := InternalStream.Write(Buffer, Count)
end;

function TFileStream.Seek(Offset: Longint; Origin: Word): Longint;
begin
  Result := InternalStream.Seek(Offset, Origin)
end;

procedure TOSFileSystem.Release;
begin
  { never auto destroy }
end;

function TOSFileSystem.Age;
var
  stamp: TFileTime;
var
  LocalFileTime: TFileTime;
begin
  GetSystemTimeAsFileTime(stamp);
  if FileTimeToLocalFileTime(stamp, LocalFileTime) and
    FileTimeToDosDateTime(LocalFileTime, LongRec(Result).Hi,
    LongRec(Result).Lo) then Exit;
  Result := -1;
end;

function TOSFileSystem.CreateFileMapping;
begin
  if targetFileSystem = Self then begin
    Result := TFileMapping.Create;
    Result.source.fileSystem := Self;
    Result.source.fileName := ExpandFileName(fileName);
    Result.target := Result.source
  end
  else
    Result := inherited CreateFileMapping(fileName, targetFileSystem)
end;

type
  TMappedFileMemoryStream = class(TMemoryStream)
  protected
    hFile: THandle;
    hMapping: THandle;
  public
    constructor Create(const fileName: string; fileOffset: integer; fileSize: integer; ShareMode: Word);
    destructor Destroy; override;
  end;

constructor TMappedFileMemoryStream.Create;
var
  ptr: pointer;
label
  fail1;
begin
  inherited Create;
  hFile := FileOpen(fileName, fmOpenRead or ShareMode);
  if hFile = INVALID_HANDLE_VALUE then exit;
  if fileSize = 0 then fileSize := GetFileSize(hFile, nil);
  hMapping := CreateFileMapping(hFile, nil, PAGE_READONLY, 0, 0, nil);
  if hMapping = 0 then begin
    fail1:
    CloseHandle(hFile);
    exit
  end;
  ptr := MapViewOfFile(hMapping, FILE_MAP_READ, 0, fileOffset, fileSize);
  if ptr = nil then begin
    CloseHandle(hMapping);
    goto fail1
  end;
  SetPointer(ptr, fileSize)
end;

destructor TMappedFileMemoryStream.Destroy;
begin
  if Memory <> nil then begin
    UnmapViewOfFile(Memory);
    CloseHandle(hMapping);
    CloseHandle(hFile);
    SetPointer(nil, 0);
  end;
  inherited
end;

function TOSFileSystem.GetFileStream;
begin
  if Mode = fmCreate then DeleteFile(FileName);

  if (Mode and $0F) = fmOpenRead then try
    Result := TMappedFileMemoryStream.Create(FileName, 0, 0, Mode and $F0);
    exit
  except
  end;
  Result := Classes.TFileStream.Create(FileName, Mode)
end;

function TOSFileSystem.FileAge;
begin
  Result := SysUtils.FileAge(FileName)
end;

function TOSFileSystem.RenameFile;
begin
  Result := SysUtils.RenameFile(OldName, NewName)
end;

function TOSFileSystem.DeleteFile;
begin
  Result := SysUtils.DeleteFile(FileName);
  if (not Result) and (GetLastError = ERROR_ACCESS_DENIED) then begin
    FileSetAttr(FileName, 0);
    Result := SysUtils.DeleteFile(FileName);
  end
end;

function TOSFileSystem.FileExists;
begin
  Result := SysUtils.FileExists(ExpandFileName(FileName))
end;

function TOSFileSystem.GetTempFileName;
var
  path, filebuf: array[0..MAX_PATH] of char;
  fname: string;
  counter: integer;
label
  loop, retry;
begin
  GetTempPath(sizeof(path), PChar(@path));
  fname := #0; //ChangeFileExt(Extracstring(FileName),'')+#0;
  loop:

  Result := '';
  counter := 20; { TUNE: mira trpelivosti }
  retry:
  if Windows.GetTempFileName(PChar(@path), PChar(@fname[1]), 0, PChar(@filebuf)) = 0 then begin
    dec(counter);
    if counter > 0 then
      goto retry
  end
  else
    Result := StrPas(PChar(@fileBuf));

  if DirectoryExists(Result) then begin
    fname := #0;
    goto loop;
  end;
  if Ext = '\' then begin
    DeleteFile(Result);
    CreateDir(Result);
  end
  else
    if Ext <> '' then begin
      DeleteFile(Result);
      if Ext[1] = '.' then
        Result := ChangeFileExt(Result, Ext)
      else
        Result := ChangeFileExt(Result, '.' + Ext)
    end
end;

function TOSFileSystem.FindFirst;
begin
  Result := SysUtils.FindFirst(Path, Attr, F)
end;

function TOSFileSystem.FindNext;
begin
  Result := SysUtils.FindNext(F)
end;

procedure TOSFileSystem.FindClose;
begin
  SysUtils.FindClose(F)
end;

function TOSFileSystem.FileSetDate;
var
  Handle: THandle;
begin
  Handle := SysUtils.FileOpen(fileName, fmOpenReadWrite or fmShareDenyNone);
  if Handle = INVALID_HANDLE_VALUE then begin
    Result := GetLastError;
    if Result = 0 then
      Result := -1
  end
  else begin
    Result := SysUtils.FileSetDate(Handle, Age);
    CloseHandle(Handle)
  end
end;

function TOSFileSystem.FileSetAttr;
begin
  Result := SysUtils.FileSetAttr(FileName, Attr)
end;

function TOSFileSystem.GetCurrentDir;
begin
  Result := SysUtils.GetCurrentDir
end;

function TOSFileSystem.SetCurrentDir;
begin
  Result := SysUtils.SetCurrentDir(Dir)
end;

function TOSFileSystem.CreateDir;
begin
  Result := SysUtils.CreateDir(Dir)
end;

function TOSFileSystem.RemoveDir;
begin
  Result := SysUtils.RemoveDir(Dir)
end;

function TOSFileSystem.ExpandFileName;
var
  found: integer;
var
  search: TSearchRec;
begin
  //Result:=SysUtils.ExpandFileName(FileName);
  Result := inherited ExpandFileName(FileName);
  found := FindFirst(Result, faAnyFile, search);
  if found = 0 then Result := ExtractFilePath(Result) + search.Name;
  FindClose(search)
end;

initialization
  fs := nil;
  OSFileSystem := TOSFileSystem.Create;
  SetDefaultFileSystem(OSFileSystem)
  finalization
  fs.Free;
  OSFileSystem.Free
end.

