{ VERSION: 2.5 }
{ 2.5 / 3.6.2006
  - nov vlastnost TMyskaUsers.WindowsAuthenticationDomain: string, kter uruje
    kde se budou ovovat hesla. Przdn hodnota znamen 'tento pota'
  2.3 / 11.10.2005
  - nov vlastnost TMyskaUsers.WindowsAuthentication: Boolean. Kdy je zapnut,
    tak se hesla ovuj v databzi uivatel mstnho potae
  2.1 / 2.10.2005
  - TMyskaApp.GenID() me pistupovat ke globlnmu genertoru pokud jeho
    jmno zan znakem '\' ( viz. GetGeneratorName() )
  2.0 / 1.10.2005
  - nov pomocn funkce ExprCommaText() pro stihn vraz
  - nov funkce TMyskaApp.GetScript(:string):string
  1.9 / 25.8.2005
  - nov funkce TMyskaStore.OpenCache(): TDataSet pro vyrbn doasnch pamovch
    tabulek a pomocn funkce FieldDefinition(): TFieldDefinition
  1.7 / 15.5.2005
  - funkce CreateStore() se pokus o autodetekci formtu souboru v ppad neznm
    ppony souboru ( viz. ValidFile() )
  1.6 / 13.5.2005
  - dal parametr do funkce CreateStore() umouje pesmrovat z ppony souboru
    na typ souboru. nap. CreateStore(..., 'pepa=fdb,karel=fdb') pouije pro ppony
    'pepa' nebo 'karel' typ souboru 'fdb'
  1.5 / 9.5.2005
  - nov vnoovateln funkce TMyskaStore.BeginUpdate a TMyskaStore.EndUpdate pro
    doasn vypnut potvrzovn transakc
  1.4 / 21.4.2005
  - nov funkce TMyskaStore.ResetGenID() a TMyskaApp.ResetGenID() pro
    vynulovn genertoru. Aby to fungovalo sprvn, nesm bt v databzi
    dn zznam s identifiktorem generovanm z toho genertoru
  1.3 / 3.4.2005
  - TMyskaStore.Params a TMyskaApp.Params se ukladaji do databaze
  - soust dotazu mou bt pkazy pro nastaven Params[]. Zapisuj
    se jako
      ParamName = ParamValue
  - zjednoduseny mechanismus aktualizace TMyskaApp.
    funkce TMyskaApp.DoUpgrade() dostane aktualni cislo verze a
    vrati cislo verze po aktualizaci ( prip. totez cislo )
  1.2 / 10.3.2005
  - nova funkce CreateStore():TMyskaStore ktera vrati spravny ovladac podle typu souboru.
    pro zaregistrovani ovladace je treba ho 'uses'nout
  - nova metoda TMyskaStore.CreateRegion():TMyskaRegion vraci handle na sdileny prostor
    v databazi s automatickou detekci zmen
  1.1 / 8.3.2005
  - upgrade aplikace se provede jenom kdyz k ni nejsou prihlaseni zadni uzivatele
}
// TODO: skupiny uzivatelu a prava
unit uMyskaDB;

interface
uses
  Classes, SysUtils, DB, uPropSet;

type
  TSelectOptions = set of (
    so_ReadOnly,
    so_ReadOnce,
    so_Command,
    so_Closed
  );

  TMyskaApp = class;

  TCommandHandler = function (const Params: Variant): TDataSet of object;

  TMyskaUsers = class;

  TMyskaUser = class
  private
    Collection: TMyskaUsers;
    FName: string;
    FID: Cardinal;
    FEnabled: Boolean;
    FFlags: Cardinal;
    FPasswordHash: string;
    procedure SetEnabled(Value: Boolean);
    procedure SetPassword(const Value: string);
    procedure SetName(const Value: string);
    procedure Modified;
  public
    property Name: string read FName write SetName;
    property Enabled: Boolean read FEnabled write SetEnabled;
    property PasswordHash: string read FPasswordHash;
    property Password: string write SetPassword;
    property Flags: Cardinal read FFlags;
    property ID: Cardinal read FID;
  end;

  TMyskaStore = class;

  TMyskaUsers = class(TComponent)
  private
    FValidateLogon: Boolean;
    FLogonDomain: string;
    FLogonCache: TStrings;
    FList: TList;
    FStore: TMyskaStore;
    FPrepared: Boolean;
    function GetItem(Index: Integer): TMyskaUser;
    procedure SetValidateLogon(Value: Boolean);
    function GetLogonDomain: string;
    procedure SetLogonDomain(const Value: string);
    function GetCommaText: string;
  protected
    procedure Clear(UnPrepare: Boolean = False);
  public
    function AddRecord(
      ID: Cardinal;
      const Name: string;
      const PasswordHash: string;
      Flags: Integer
    ): TMyskaUser;
  public
    constructor Create(AStore: TMyskaStore);
    destructor Destroy; override;
    function Add(const UserName: string; const Password: string; Enabled: Boolean = True): TMyskaUser;
    function Find(const UserName: string): TMyskaUser; overload;
    function Find(UserID: Cardinal): TMyskaUser; overload;
    function Count: Integer;
    function Login(const UserName: string; const Password: string): Boolean; overload;
    function Login(const UserName: string; const Password: string; var UserID: Cardinal): Boolean; overload;
    property Items[Index: Integer]: TMyskaUser read GetItem; default;
    property WindowsAuthentication: Boolean read FValidateLogon write SetValidateLogon default False;
    property WindowsAuthenticationDomain: string read GetLogonDomain write SetLogonDomain;
    property CommaText: string read GetCommaText;
  end;

  TOpenMode = (om_Read, om_Write, om_ReadWrite);

  TMyskaRegion = class(TComponent)
  protected
    FOnChange: TNotifyEvent;
    procedure SetOnChange(Handler: TNotifyEvent); virtual; abstract;
  public
    function Open(Mode: TOpenMode): TObject; virtual; abstract;
    function Changed: Boolean; virtual; abstract;
    property OnChange: TNotifyEvent read FOnChange write SetOnChange;
  end;

  TMyskaStoreFactory = class of TMyskaStore;

  TMyskaPropSet = class(TPropSet)
  public
    property Modified;
  end;

  TFieldDefinition = record
    Name: string;
    DataType: TFieldType;
    Size: Integer;
  end;

  TMyskaStore = class(TComponent)
  protected
    FDBQueries: TPropSet;
  public
    property DBQueries: TPropSet read FDBQueries;
  private
    FUpdateCount: Integer;
    FGenerators: TStrings;
    FRegions: TStrings;
    FLocksPrepared: Boolean;
    FAppsPrepared: Boolean;
    FGeneratorsPrepared: Boolean;
    FSessionsPrepared: Boolean;
    FRegionsPrepared: Boolean;
    FPropertyBlobsPrepared: Boolean;
    FSessionID: Cardinal;
    FUserID: Cardinal;
    FUserName: string;
    FUsers: TMyskaUsers;
    procedure SetUserName(const Value: string);
  private
    FConnection: string;
    FApps: TList;
    FParams: TMyskaPropSet;
    FConnected: Boolean;
    FCommandNames: TStrings;
    FCommands: array of TCommandHandler;
    procedure SetConnected(Value: Boolean);
    function Execute(const Command: string; const Params: Variant; IsFunction: Boolean): TDataSet;
    procedure OpenSession(const AppID: string);
    procedure CloseSession(const AppID: string);
    procedure LoadUsers;
    procedure PreparePropertyBlobs;
    function InternalGenID(const AGeneratorName: string; Reset: Boolean): Cardinal;
  protected
    procedure Add(Sender: TMyskaApp);
    procedure Remove(Sender: TMyskaApp);
  public
    function Subst(const Text: string; const Args: array of const): string; overload;
    function Subst(const Text: string): string; overload;
  protected
    procedure Check(Condition: Boolean; const Msg: string = ''); overload;
    procedure Check(Condition: Boolean; const Fmt: string; const Args: array of const); overload;
    procedure RegisterCommand(const Command: string; Handler: TCommandHandler);
    procedure ConfigureQueries; virtual;
  protected
    procedure DoParseSQL(const Query: string; Statements: TStrings); virtual;
    procedure DoAdd(Sender: TMyskaApp); virtual;
    procedure DoRemove(Sender: TMyskaApp); virtual;
    procedure DoConnect; virtual;
    procedure DoDisconnect; virtual;
    function DoExec(const Query: string; Options: TSelectOptions): TDataSet; virtual;
    function DoGenID(const GeneratorName: string): Cardinal; virtual; abstract;
    procedure DoResetGenID(const GeneratorName: string); virtual; abstract;
    function DoPrepareGenerator(const GeneratorName: string): string; virtual;
    procedure DoPrepareGenerators; virtual;
    function DoLock(const LockName: string): TObject; virtual;
    procedure DoPrepareLocks; virtual;
    procedure DoPrepareApps; virtual;
    procedure DoPrepareSessions; virtual;
    procedure DoOpenSession(const AppID: string; UserID: Cardinal); virtual;
    procedure DoCloseSession(const AppID: string); virtual;
    procedure DoAuthenticateSession(UserID: Cardinal); virtual;
    procedure DoLoadUsers; virtual;
    procedure DoModifyUser(User: TMyskaUser; IsNew: Boolean = False); virtual;
    procedure DoCleanUp; virtual;
    function ExclusiveAccess: Boolean; virtual;
    procedure DoPrepareRegions; virtual;
    function DoPrepareRegion(const RegionName: string; var Hint: Integer): string; virtual;
    function DoCreateRegion(const RegionName: string; Hint: Integer): TMyskaRegion; virtual; abstract;
    procedure DoPreparePropertyBlobs; virtual;
    procedure DoLoadPropertyBlob(const ID: string; Stream: TStream); virtual;
    procedure DoSavePropertyBlob(const ID: string; Stream: TStream); virtual;
    procedure DoBeginUpdate; virtual;
    procedure DoEndUpdate; virtual;
  protected
    procedure LoadProperties(const ID: string; Properties: TMyskaPropSet; UpdateMode: TPropSetUpdateMode = umClear);
    procedure SaveProperties(const ID: string; Properties: TMyskaPropSet);
  protected
    function Exec(const Query: string; Options: TSelectOptions; const Args: array of const; Variables: TPropSet): TDataSet; overload;
    procedure ExecScript(Stream: TStream; Variables: TPropSet); overload;
    procedure ExecScript(const ScriptFileName: string; Variables: TPropSet); overload;
  protected
    class function ValidFile(const Header: string): Boolean; virtual;
  public
    constructor Create(AnOwner: TComponent); override;
    destructor Destroy; override;

    function Lock(const LockName: string): TObject;
    function CreateRegion(const RegionName: string): TMyskaRegion;
    function GenID(const GeneratorName: string): Cardinal;
    procedure ResetGenID(const GeneratorName: string);

    function Exec(const Query: string; Options: TSelectOptions = []): TDataSet; overload;
    function Exec(const Query: string; Options: TSelectOptions; const Args: array of const): TDataSet; overload;

    procedure ExecScript(Stream: TStream); overload;
    procedure ExecScript(const ScriptFileName: string); overload;

    function Select(const Query: string): Variant; overload;
    function Select(const Query: string; const DefaultValue: Variant): Variant; overload;
    function Select(const Query: string; const Args: array of const): Variant; overload;
    function Select(const Query: string; const Args: array of const; const DefaultValue: Variant): Variant; overload;

    function Exists(const Query: string): Boolean; overload;
    function Exists(const Query: string; const Args: array of const): Boolean; overload;

    function OpenCache(AnOwner: TComponent; const Fields: array of TFieldDefinition): TDataSet; overload; virtual; abstract;
    function OpenCache(const Fields: array of TFieldDefinition): TDataSet; overload;

    procedure BeginUpdate;
    procedure EndUpdate;

    property Params: TMyskaPropSet read FParams;
    property Connected: Boolean read FConnected write SetConnected;
    property Connection: string read FConnection write FConnection;
    property SessionID: Cardinal read FSessionID;
    property UserID: Cardinal read FUserID;
    property UserName: string read FUserName write SetUserName;
    property Users: TMyskaUsers read FUsers;
  end;

  TMyskaApp = class(TComponent)
  protected
    FDBQueries: TPropSet;
  public
    property DBQueries: TPropSet read FDBQueries;
  private
    FAppVersion: Integer;
    FParams: TMyskaPropSet;
    FStore: TMyskaStore;
    FAppID: string;
    FConnected: Boolean;
    function GetUsers: TMyskaUsers;
    procedure SetStore(Value: TMyskaStore);
    procedure SetAppID(const Value: string);
    procedure SetConnected(Value: Boolean);
    procedure Connect;
    procedure Disconnect;
    procedure Upgrade(FromVersion: Integer; ToVersion: Integer);
  public
    function Subst(const Text: string; const Args: array of const): string; overload;
    function Subst(const Text: string): string; overload;
  protected
    procedure Check(Condition: Boolean; const Msg: string = ''); overload;
    procedure Check(Condition: Boolean; const Fmt: string; const Args: array of const); overload;
    procedure DoInstall; virtual;
    // dostane verzi ze ktere ma aktualizovat a vrati verzi na kterou se mu to povedlo
    function DoUpgrade(OldVersion: Integer): Integer; virtual;
    procedure DoConnect; virtual;
    procedure DoDisconnect; virtual;
    procedure ConfigureQueries; virtual;
  public
    constructor Create(AnOwner: TComponent); override;
    destructor Destroy; override;
    function Lock(const LockName: string): TObject;
    function CreateRegion(const RegionName: string): TMyskaRegion;
    function GenID(const GeneratorName: string): Cardinal;
    procedure ResetGenID(const GeneratorName: string);

    function Exec(const Query: string; Options: TSelectOptions = []): TDataSet; overload;
    function Exec(const Query: string; Options: TSelectOptions; const Args: array of const): TDataSet; overload;

    function GetScript(const ID: string): string; virtual;

    procedure ExecScript(Stream: TStream); overload;
    procedure ExecScript(const ScriptFileName: string); overload;

    function Select(const Query: string): Variant; overload;
    function Select(const Query: string; const DefaultValue: Variant): Variant; overload;
    function Select(const Query: string; const Args: array of const): Variant; overload;
    function Select(const Query: string; const Args: array of const; const DefaultValue: Variant): Variant; overload;

    function Exists(const Query: string): Boolean; overload;
    function Exists(const Query: string; const Args: array of const): Boolean; overload;

    procedure BeginUpdate;
    procedure EndUpdate;

    property Store: TMyskaStore read FStore write SetStore;
    property Params: TMyskaPropSet read FParams;
    property AppID: string read FAppID write SetAppID;
    property AppVersion: Integer read FAppVersion write FAppVersion;
    property Connected: Boolean read FConnected write SetConnected;
    property Users: TMyskaUsers read GetUsers;
  end;

  TMyskaSession = class(TComponent)
  private
    FApp: TMyskaApp;
    FStore: TMyskaStore;
    FUserName: string;
    FConnected: Boolean;
    procedure SetApp(Value: TMyskaApp);
    procedure SetStore(Value: TMyskaStore);
    procedure SetUserName(const Value: string);
    procedure SetConnected(Value: Boolean);
  protected
    procedure Check(Condition: Boolean; const Msg: string = '');
    procedure DoConnect; virtual;
    procedure DoDisconnect; virtual;
  public
    property App: TMyskaApp read FApp write SetApp;
    property Store: TMyskaStore read FStore write SetStore;
    property UserName: string read FUserName write SetUserName;
    property Connected: Boolean read FConnected write SetConnected;
  end;

function HashPassword(const Password: string): string;

function CreateStore(AnOwner: TComponent; const Connection: string; const FileTypeAliases: string = ''): TMyskaStore;
procedure RegisterFactory(Factory: TMyskaStoreFactory; const FileTypes: array of string);

function FieldDefinition(const Name: string; DataType: TFieldType; Size: Integer = 0): TFieldDefinition;

procedure ExprCommaText(List: TStrings; const Text:string);

implementation
uses
  Variants, SynaCode, SystemUtils;

procedure ExprCommaText(List: TStrings; const Text:string);
var
  p:integer;
  n:integer;
  token:string;
  q:char;
  isQ:boolean;
  br:integer;
begin
  list.Clear;
  n:=Length(Text);
  p:=1;
  token:='';
  br:=0;
  isQ:=false;
  while p<=n do begin
    case Text[p] of
    '"','''':
      if isQ and (Text[p]=q) then
        isQ:=false
      else
      if not isQ then begin
        q:=Text[p];
        isQ:=true
      end;

    '(':
      if not isQ then inc(br);

    ')':
      if not isQ then dec(br);

    ',':
      if (not isQ) and (br=0) then begin
        list.Add(Trim(token));
        token:='';
        inc(p);
        continue
      end
    end;
    token:=token+Text[p];
    inc(p)
  end;
  token:=Trim(token);
  if token<>'' then list.Add(token)
end;

//--------------------------------------------------------------------------

procedure Check(Condition: Boolean; Sender: TComponent; const Msg: string = '');
var
  S: string;
begin
  if not Condition then begin
    if Assigned(Sender) then begin
      S := Sender.Name + ':' + Sender.ClassName + ' error: '
    end else
      S := '';

    raise Exception.Create(S + Msg)
 end
end;

//--------------------------------------------------------------------------

const
  UserFlagDisabled = 1 shl 0;

procedure TMyskaUser.Modified;
begin
  Collection.FStore.DoModifyUser(Self);
end;

procedure TMyskaUser.SetEnabled(Value: Boolean);
begin
  if Enabled <> Value then begin
    FEnabled := Value;
    if FEnabled then
      FFlags := FFlags and (not UserFlagDisabled)
    else
      FFlags := FFlags or UserFlagDisabled;
    Modified
  end
end;

procedure TMyskaUser.SetPassword(const Value: string);
var
  Hash: string;
begin
  Hash := HashPassword(Value);
  if Hash <> FPasswordHash then begin
    FPasswordHash := Hash;
    Modified
  end
end;

procedure TMyskaUser.SetName(const Value: string);
begin
  if not SameText(Name, Value) then begin
    Collection.FStore.Check(Collection.Find(Value) = nil, 'Duplicate user name');
    FName := Value;
    Modified
  end
end;

//--------------------------------------------------------------------------

function TMyskaUsers.GetItem(Index: Integer): TMyskaUser;
begin
  Result := TMyskaUser(FList[Index])
end;

procedure TMyskaUsers.Clear(UnPrepare: Boolean);
var
  I: Integer;
begin
  for I := FList.Count - 1 downto 0 do
    Items[I].Free;
  FList.Clear;
  if UnPrepare then
    FPrepared := False
end;

const
  DefaultLogonDomain = '.'; // 'this computer' in the language of SystemUtils.ValidateLogon()

constructor TMyskaUsers.Create(AStore: TMyskaStore);
begin
  inherited Create(nil);
  FStore := AStore;
  FList := TList.Create;
  FLogonCache := TStringList.Create;
  TStringList(FLogonCache).Sorted := True;
  FLogonDomain := DefaultLogonDomain
end;

destructor TMyskaUsers.Destroy;
begin
  if Assigned(FList) then begin
    Clear;
    FList.Free;
  end;
  inherited
end;

function TMyskaUsers.Count: Integer;
begin
  if not FPrepared then begin
    if Assigned(FStore) then
      FStore.LoadUsers;
    FPrepared := True
  end;
  Result := FList.Count
end;

function TMyskaUsers.Find(const UserName: string): TMyskaUser;
var
  I: Integer;
begin
  for I := Count - 1 downto 0 do begin
    Result := Items[I];
    if SameText(Result.Name, UserName) then
      exit
  end;
  Result := nil
end;

function TMyskaUsers.Find(UserID: Cardinal): TMyskaUser;
var
  I: Integer;
begin
  for I := Count - 1 downto 0 do begin
    Result := Items[I];
    if Result.ID = UserID then
      exit
  end;
  Result := nil
end;

function TMyskaUsers.GetCommaText: string;
var
  I: Integer;

  function Password(Item: TMyskaUser): string;
  begin
    if Item.Enabled then
      Result := Item.PasswordHash
    else
      Result := '*'
  end;

begin
  Result := '';
  for I := 0 to Count - 1 do begin
    if Result <> '' then
      Result := Result + ',';
    Result := Result + Items[I].Name + '=' + Password(Items[I])
  end;
end;

function HashPassword(const Password: string): string;
var
  I: Integer;
  S: string;
begin
  S := SynaCode.HMAC_MD5(Password, 'MYS');
  Result := '';
  for I := 1 to Length(S) do
    Result := Result + IntToHex(Ord(S[I]), 2)
end;

function TMyskaUsers.AddRecord(ID: Cardinal; const Name: string;
  const PasswordHash: string; Flags: Integer): TMyskaUser;
var
  Item: TMyskaUser;
begin
  Item := TMyskaUser.Create;
  FList.Add(Item);
  Item.Collection := Self;
  Item.FName := Name;
  Item.FID := ID;
  Item.FPasswordHash := PasswordHash;
  Item.FFlags := Flags;
  Item.FEnabled := (Flags and UserFlagDisabled) = 0;
  Result := Item
end;

function TMyskaUsers.Add(const UserName: string; const Password: string; Enabled: Boolean = True): TMyskaUser;
var
  Lck: TObject;
  PasswordHash: string;
begin
  // TODO: a co kdyz se s tim machruje z vic pocitacu najednou ?
  Lck := FStore.Lock('mys.users');
  try
    Result := Find(UserName);
    if Assigned(Result) then begin
      PasswordHash := HashPassword(Password);
      if (Result.FPasswordHash <> PasswordHash) or
         (Result.FEnabled <> Enabled) then begin
        Result.FPasswordHash := PasswordHash;
        Result.FEnabled := Enabled;
        if Result.FEnabled then
          Result.FFlags := Result.FFlags and (not UserFlagDisabled)
        else
          Result.FFlags := Result.FFlags or UserFlagDisabled;
        FStore.DoModifyUser(Result, False)
      end
    end else begin
      Result := AddRecord(FStore.GenID('MYS.USERID'), UserName, HashPassword(Password), Ord(not Enabled) * UserFlagDisabled);
      FStore.DoModifyUser(Result, True)
    end
  finally
    Lck.Free
  end
end;

function TMyskaUsers.Login(const UserName: string; const Password: string): Boolean;
var
  UserID: Cardinal;
begin
  Result := Login(UserName, Password, UserID);
  if Result then
    FStore.UserName := UserName
end;

function TMyskaUsers.Login(const UserName: string; const Password: string; var UserID: Cardinal): Boolean;

  function ValidatePassword(User: TMyskaUser; const Password: string): Boolean;
  var
    Key: string;
  begin
    if WindowsAuthentication then begin
      Key := User.Name + ':' + HashPassword(Password);
      Result := FLogonCache.IndexOf(Key) >= 0;
      if not Result then begin
        Result := SystemUtils.ValidateLogon(User.Name, Password, FLogonDomain) = 0;
        if Result then
          FLogonCache.Add(Key)
      end
    end else
      Result := User.FPasswordHash = HashPassword(Password)
  end;

var
  User: TMyskaUser;
begin
  User := Find(UserName);
  if Assigned(User) and User.Enabled and ValidatePassword(User, Password) then begin
    UserID := User.ID;
    Result := True;
  end else begin
    UserID := 0;
    Result := False
  end
end;

procedure TMyskaUsers.SetValidateLogon(Value: Boolean);
begin
  if FValidateLogon <> Value then begin
    FValidateLogon := Value;
    FLogonCache.Clear;
  end
end;

function TMyskaUsers.GetLogonDomain: string;
begin
  Result := FLogonDomain;
  if Result = DefaultLogonDomain then
    Result := ''
end;

procedure TMyskaUsers.SetLogonDomain(const Value: string);
begin
  if FLogonDomain <> Value then begin
    FLogonDomain := Value;
    if FLogonDomain = '' then
      FLogonDomain := DefaultLogonDomain;
    if FValidateLogon then
      FLogonCache.Clear
  end
end;

//--------------------------------------------------------------------------

constructor TMyskaStore.Create(AnOwner: TComponent);
begin
  FApps := TList.Create;
  FParams := TMyskaPropSet.Create(nil);
  FCommandNames := TStringList.Create;
  TStringList(FCommandNames).Sorted := True;
  FUsers := TMyskaUsers.Create(Self);
  inherited Create(AnOwner);
end;

destructor TMyskaStore.Destroy;
begin
  Connected := False;
  FreeAndNil(FApps);
  FreeAndNil(FParams);
  FreeAndNil(FCommandNames);
  FreeAndNil(FUsers);
  inherited
end;

procedure TMyskaStore.Add(Sender: TMyskaApp);
var
  AppVersion: Integer;
  Lck: TObject;
begin
  FApps.Add(Sender);
  try
    Connected := True;

    if not FAppsPrepared then begin
      DoPrepareApps;
      FAppsPrepared := True
    end;

    Lck := Lock('mys.apps');
    try
      DoAdd(Sender);

      AppVersion := Select('{mys.app.getversion}', [Sender.AppID], -1);

      LoadProperties(Sender.AppID, Sender.Params, umAdd { TODO: ? });

      if AppVersion < 0 then begin
        Sender.DoInstall;
        SaveProperties(Sender.AppID, Sender.Params);
        Exec('{mys.app.insert}', [so_Command], [Sender.AppID, Sender.AppVersion]);
      end else
      if AppVersion < Sender.AppVersion then begin
        Check(not Exists('{mys.app.sessions}', [Sender.AppID]), 'Can not upgrade: %s in use', [Sender.AppID]);
        Sender.Upgrade(AppVersion, Sender.AppVersion);
        SaveProperties(Sender.AppID, Sender.Params);
        Exec('{mys.app.setversion}', [so_Command], [Sender.AppID, Sender.AppVersion])
      end else
      if AppVersion > Sender.AppVersion then
        // TUNE:
        Sender.Check(False, 'DB Version %d ( expected version %d)', [AppVersion, Sender.AppVersion]);

      OpenSession(Sender.AppID)
    finally
      Lck.Free
    end
  except
    FApps.Remove(Sender);
    raise
  end
end;

procedure TMyskaStore.Remove(Sender: TMyskaApp);
begin
  SaveProperties(Sender.AppID, Sender.Params);

  CloseSession(Sender.AppID);

  FApps.Remove(Sender);

  DoRemove(Sender);
  { TODO: ?
  if FApps.Count = 0 then
    Connected := False
  }
end;

procedure TMyskaStore.Check(Condition: Boolean; const Msg: string);
begin
  uMyskaDB.Check(Condition, Self, Msg)
end;

procedure TMyskaStore.Check(Condition: Boolean; const Fmt: string; const Args: array of const);
begin
  if not Condition then
    uMyskaDB.Check(Condition, Self, Format(Fmt, Args))
end;

procedure TMyskaStore.OpenSession(const AppID: string);
begin
  if not FSessionsPrepared then begin
    DoPrepareSessions;
    FSessionsPrepared := True
  end;
  DoOpenSession(UpperCase(AppID), UserID)
end;

procedure TMyskaStore.CloseSession(const AppID: string);
begin
  DoCloseSession(UpperCase(AppID))
end;

// TODO: hlidej zmeny properties ulozenych v databazi pres regiony

procedure TMyskaStore.SetConnected(Value: Boolean);
begin
  if FConnected <> Value then
    if Value then begin
      DoConnect;

      FGenerators := TStringList.Create;
      FRegions := TStringList.Create;

      FConnected := True;

      if ExclusiveAccess then
        DoCleanUp;

      FSessionID := GenID('MYS.SESSION');

      OpenSession('MYS');

      LoadProperties('MYS', Params, umAdd { TODO: ? });
    end else begin
      if Assigned(FApps) then
        while FApps.Count <> 0 do
          TMyskaApp(FApps[0]).Connected := False;

      SaveProperties('MYS', Params);

      CloseSession('MYS');

      DoDisconnect;

      FreeAndNil(FGenerators);
      FreeAndNil(FRegions);
      FLocksPrepared := False;
      FAppsPrepared := False;
      FGeneratorsPrepared := False;
      FSessionsPrepared := False;
      FRegionsPrepared := False;
      FPropertyBlobsPrepared := False;
      
      FUsers.Clear(True);

      FConnected := False;

      FUserName := '';
      FUserID := 0
    end
end;

procedure TMyskaStore.PreparePropertyBlobs;
begin
  Connected := True;
  if not FPropertyBlobsPrepared then begin
    DoPreparePropertyBlobs;
    FPropertyBlobsPrepared := True;
  end;
end;

procedure TMyskaStore.LoadProperties(const ID: string; Properties: TMyskaPropSet; UpdateMode: TPropSetUpdateMode);
var
  Stream: TStream;
begin
  if Assigned(Properties) then begin
    PreparePropertyBlobs;
    Stream := TMemoryStream.Create;
    try
      DoLoadPropertyBlob(UpperCase(ID), Stream);
      Stream.Position := 0;
      Properties.LoadFromStream(Stream, UpdateMode);
      Properties.Modified := False
    finally
      Stream.Free
    end;
  end
end;

procedure TMyskaStore.SaveProperties(const ID: string; Properties: TMyskaPropSet);
var
  Stream: TStream;
begin
  if Assigned(Properties) and Properties.Modified then begin
    PreparePropertyBlobs;
    Stream := TMemoryStream.Create;
    try
      Properties.SaveToStream(Stream);
      Stream.Position := 0;
      DoSavePropertyBlob(UpperCase(ID), Stream);
      Properties.Modified := False
    finally
      Stream.Free
    end;
  end
end;

procedure TMyskaStore.LoadUsers;
begin
  Connected := True;     // TODO: ?
  DoLoadUsers
end;

procedure TMyskaStore.SetUserName(const Value: string);
var
  User: TMyskaUser;
  ID: Cardinal;
begin
  User := Users.Find(Value);
  if Assigned(User) and User.Enabled then begin
    ID := User.ID;
    FUserName := User.Name
  end else begin
    FUserName := '';
    ID := 0
  end;
  if UserID <> ID then begin
    FUserID := ID;
    if Connected then
      DoAuthenticateSession(UserID)
  end
end;

function TMyskaStore.Subst(const Text: string): string;
begin
  Result := Subst(Text, [])
end;

const
  TemporaryPrefix = '@';

function TMyskaStore.Subst(const Text: string; const Args: array of const): string;
var
  I: Integer;
  Leva, Prava: Integer;
  Key: string;
  KeyParams: string;

  procedure CheckUnknownKeyword(Condition: Boolean; const Key: string);
  begin
    Check(Condition, 'Unknown keyword {%s}' { TUNE: }, [Key])
  end;

  // Params.ValueFromIndex[I]
  function Eval(Commands: TPropSet; Command: Integer; const Params: string): string;

    function Cmd(Arity: Integer): string;
    begin
      Result := Commands.ArrayValueFromIndex[Command, Arity];
      if (Result = '') and (Arity = 0) then begin
        Result := Commands.ArrayValueFromIndex[Command, 1];
        if Result = '' then
          Result := Commands.ArrayValueFromIndex[Command, 2];
      end;
      CheckUnknownKeyword(Result <> '', Key)
    end;

  var
    Items: TStrings;
  begin
    if Params = '' then
      Result := Cmd(0)
    else begin
      Items := TStringList.Create;
      try
        ExprCommaText(Items, Params);
        case Items.Count of
        0:
          Check(False);
        1:
          Result := Format(Cmd(1), [Items[0]]);
        2:
          Result := Format(Cmd(2), [Items[0], Items[1]]);
        else
          Check(False)
        end
      finally
        Items.Free
      end
    end
  end;

begin
  Result := Text;
  while True do begin
    Leva := Pos('{', Result);
    if Leva = 0 then break;
    Prava := Pos('}', Result);
    if Prava = 0 then
      // Prava := Length(Result) + 1;
      CheckUnknownKeyword(False, Copy(Result, Leva + 1, MaxInt));

    (* Result[leva]='{', Result[prava]='}'.
      najdi slovo mezi nema *)
    for I := Prava - 1 downto Leva do
      if Result[I] = '{' then begin
        Leva := I;
        break
      end;

    Key := Copy(Result, Leva + 1, Prava - Leva - 1);
    if (Key <> '') and (Key[1] = TemporaryPrefix) then
      Delete(Key, 1, 1);

    I := Pos('(', Key);
    if I = 0 then
      KeyParams := ''
    else begin
      KeyParams := Copy(Key, I + 1, MaxInt);
      if KeyParams <> '' then
        SetLength(KeyParams, Length(KeyParams) - 1);
      SetLength(Key, I - 1)
    end;

    I := Params.IndexOf(Key);
    if I >= 0 then
      Result := Copy(Result, 1, Leva - 1) + Eval(Params, I, KeyParams) + Copy(Result, Prava + 1, MaxInt)
    else begin
      { slovo neni v seznamu }
      CheckUnknownKeyword(False, Key)
    end
  end;

  if Length(Args) > 0 then
    Result := Format(Result, Args)
end;

function TMyskaStore.Exec(const Query: string; Options: TSelectOptions; const Args: array of const): TDataSet;
begin
  Result := Exec(Query, Options, Args, Params)
end;

function TMyskaStore.Exec(const Query: string; Options: TSelectOptions; const Args: array of const; Variables: TPropSet): TDataSet;

  function IsWord(const S: string; Indexed: Boolean = False): Boolean;
  var
    I: Integer;
    IDs: set of char;
  begin
    Result := False;

    if Indexed then
      IDs := ['(', ')']
    else
      IDs := [];

    if (S = '') or (not (S[1] in ['_', 'A'..'Z', 'a'..'z', TemporaryPrefix])) then exit;
    for I := Length(S) downto 2 do
      if not (S[I] in ['.', '_', 'A'..'Z', 'a'..'z', '0'..'9']) then
        if not (S[I] in IDs) then
          exit
        else
          IDs := IDs - [S[I]];
    Result := True;
  end;

  function ParamList(const Params: string): Variant;
  const
    ChComma = #1;
  var
    List: TStrings;
    I: Integer;
    InQ: Boolean;
    S: string;
    HasQ: Boolean;

    function VarItem(const S: string): Variant;
    begin
      if S = '' then
        Result := Unassigned
      else
      if S[1] = '''' then
        Result := Copy(S, 2, Length(S) - 2)
      else
        Result := StrToIntDef(S, 0)
    end;

  begin
    List := TStringList.Create;
    try
      InQ := False;
      S := Params;
      HasQ := False;
      if Pos(',', S) <> 0 then begin
        for I := 1 to Length(S) do
          case S[I] of
          '''':
            InQ := not InQ;

          ',':
            if InQ then begin
              S[I] := ChComma;
              HasQ := True
            end
          end;

        S := StringReplace(S, ',', #13#10, [rfReplaceAll]);
      end;
      if HasQ then
        S := StringReplace(S, ChComma, ',', [rfReplaceAll]);
      List.Text := S;
      if List.Count = 0 then
        Result := Unassigned
      else begin
        Result := VarArrayCreate([0, List.Count - 1], varVariant);
        for I := 0 to List.Count - 1 do
          Result[I] := VarItem(Trim(List[I]))
      end
    finally
      List.Free
    end
  end;

var
  Q: string;
  I, J, S: Integer;
  Cmd: string;
  Statements: TStrings;

  procedure ExpandSQL(Index: Integer);
  var
    Lines: TStrings;
    I: Integer;
  begin
    Lines := TStringList.Create;
    try
      DoParseSQL(Subst(Statements[Index]), Lines);
      case Lines.Count of
      0: Statements[Index] := '';
      1: Statements[Index] := Lines[0];
      else
        Statements.Delete(Index);
        for I := 0 to Lines.Count - 1 do
          Statements.Insert(Index + I, Lines[I]);
      end;
    finally
      Lines.Free
    end
  end;

  function GetStatement(Index: Integer): string;
  begin
    Result := Statements[Index];
    if (Result <> '') and (Result[Length(Result)] = ';') then
      SetLength(Result, Length(Result) - 1);
    Result := Trim(Result)
  end;

var
  Temps: TPropSet;

  procedure SetVariable(const ID: string; const Value: string);
  begin
    if ID[1] = TemporaryPrefix then begin
      if not Assigned(Temps) then begin
        Temps := TPropSet.Create(nil);
        Variables.Add(Temps);
      end;
      Temps.AddText(Copy(ID, 2, MaxInt) + '=' + Value);
    end else
      Variables.AddText(ID + '=' + Value);
  end;

var
  Handled: Boolean;
begin
  Connected := True;

  Statements := TStringList.Create;
  try
    if Length(Args) > 0 then
      DoParseSQL(Subst(Query, Args), Statements)
    else
      DoParseSQL(Query, Statements);

    Result := nil;
    Temps := nil;
    try
      try
        S := 0;
        while S < Statements.Count do begin
          // TODO: nastav Options pro predposledni prikazy na so_Command
          ExpandSQL(S);

          Q := GetStatement(S);
          FreeAndNil(Result);
          Handled := False;

          if Q = '' then
            Handled := True
          else begin

            if not Handled then begin
              I := Pos('=', Q);
              if I <> 0 then begin
                Cmd := Trim(Copy(Q, 1, I - 1));
                if IsWord(Cmd, True) then begin
                  SetVariable(Cmd, Copy(Q, I + 1, MaxInt));
                  Handled := True
                end
              end
            end;

            if not Handled then begin
              I := Pos('(', Q);
              if I <> 0 then begin
                Cmd := Trim(UpperCase(Copy(Q, 1, I - 1)));
                if IsWord(Cmd) then begin
                  J := Length(Q);
                  while (J > I) and (Q[J] <> ')') do Dec(J);
                  Result := Execute(Cmd, ParamList(Copy(Q, I + 1, J - I - 1)), not (so_Command in Options));
                  Handled := True
                end
              end;
            end;

            if not Handled then begin
              Result := DoExec(Q, Options);
              Handled := True
            end
          end;

          Inc(S)
        end
      except
        Result.Free;
        raise
      end
    finally
      Temps.Free
    end
  finally
    Statements.Free
  end
end;

procedure TMyskaStore.ExecScript(Stream: TStream);
begin
  ExecScript(Stream, Params)
end;

procedure TMyskaStore.ExecScript(Stream: TStream; Variables: TPropSet);
var
  Query: string;
begin
  SetLength(Query, Stream.Size - Stream.Position);
  if Query <> '' then begin
    Stream.ReadBuffer(Query[1], Length(Query));
    Exec(Query, [so_Command], [], Variables)
  end
end;

procedure TMyskaStore.ExecScript(const ScriptFileName: string);
begin
  ExecScript(ScriptFileName, Params)
end;

procedure TMyskaStore.ExecScript(const ScriptFileName: string; Variables: TPropSet);
var
  Stream: TStream;
begin
  Stream := TFileStream.Create(ScriptFileName, fmOpenRead or fmShareDenyWrite);
  try
    ExecScript(Stream, Variables)
  finally
    Stream.Free
  end
end;

procedure TMyskaStore.RegisterCommand(const Command: string; Handler: TCommandHandler);
var
  I: Integer;
begin
  I := FCommandNames.IndexOf(Command);
  if I < 0 then begin
    I := FCommandNames.AddObject(Command, TObject(FCommandNames.Count));
    SetLength(FCommands, Length(FCommands) + 1);
  end;
  FCommands[Integer(FCommandNames.Objects[I])] := Handler
end;

function TMyskaStore.Execute(const Command: string; const Params: Variant; IsFunction: Boolean): TDataSet;
var
  I: Integer;
begin
  I := FCommandNames.IndexOf(Command);
  Check(I >= 0, 'Unknown command ''%s''', [Command]);
  Result := FCommands[Integer(FCommandNames.Objects[I])](Params);
  if not IsFunction then
    FreeAndNil(Result)
end;

function TMyskaStore.Exec(const Query: string; Options: TSelectOptions): TDataSet;
begin
  Result := Exec(Query, Options, [])
end;

function TMyskaStore.Select(const Query: string): Variant;
begin
  Result := Select(Query, [], Unassigned)
end;

function TMyskaStore.Select(const Query: string; const Args: array of const): Variant;
begin
  Result := Select(Query, Args, Unassigned)
end;

function TMyskaStore.Select(const Query: string; const Args: array of const; const DefaultValue: Variant): Variant;
var
  D: TDataSet;
begin
  Result := DefaultValue;
  D := Exec(Query, [so_ReadOnly, so_ReadOnce], Args);
  try
    if Assigned(D) and ((not D.Eof) and (D.FieldCount > 0)) then
      Result := D.Fields[0].Value
  finally
    D.Free
  end
end;

function TMyskaStore.Select(const Query: string; const DefaultValue: Variant): Variant;
begin
  Result := Select(Query, [], DefaultValue)
end;

function TMyskaStore.OpenCache(const Fields: array of TFieldDefinition): TDataSet;
begin
  Result := OpenCache(nil, Fields)
end;

function TMyskaStore.Exists(const Query: string): Boolean;
begin
  Result := Exists(Query, [])
end;

function TMyskaStore.Exists(const Query: string; const Args: array of const): Boolean;
var
  D: TDataSet;
begin
  D := Exec(Query, [so_ReadOnly, so_ReadOnce], Args);
  try
    Result := Assigned(D) and (not D.Eof)
  finally
    D.Free
  end
end;

const
  ContextSeparator = '\';

function GetGeneratorName(const GeneratorName: string): string;
begin
  Result := GeneratorName;
  if Result[1] = ContextSeparator then
    Delete(Result, 1, 1);
  Result := StringReplace(Result, ContextSeparator, '', [rfReplaceAll])
end;

function TMyskaStore.InternalGenID(const AGeneratorName: string; Reset: Boolean): Cardinal;
var
  I: Integer;
  S: string;
  GeneratorName: string;
begin
  GeneratorName := GetGeneratorName(AGeneratorName);
  Connected := True;
  Result := 0;
  I := FGenerators.IndexOfName(GeneratorName);
  if I < 0 then begin
    if not FGeneratorsPrepared then begin
      DoPrepareGenerators;
      FGeneratorsPrepared := True
    end;

    S := DoPrepareGenerator(GeneratorName);
    FGenerators.Values[GeneratorName] := S;
    if Reset then
      DoResetGenID(S)
    else
      Result := DoGenID(S)
  end else begin
    if Reset then
      DoResetGenID(FGenerators.Values[GeneratorName])
    else
      Result := DoGenID(FGenerators.Values[GeneratorName])
  end
end;

function TMyskaStore.GenID(const GeneratorName: string): Cardinal;
begin
  Result := InternalGenID(GeneratorName, False)
end;

procedure TMyskaStore.ResetGenID(const GeneratorName: string);
begin
  InternalGenID(GeneratorName, True)
end;

function TMyskaStore.Lock(const LockName: string): TObject;
begin
  Connected := True;
  if not FLocksPrepared then begin
    DoPrepareLocks;
    FLocksPrepared := True
  end;
  Result := DoLock(LockName)
end;

function TMyskaStore.CreateRegion(const RegionName: string): TMyskaRegion;
var
  I: Integer;
  Hint: Integer;
  S: string;
begin
  Connected := True;
  I := FRegions.IndexOfName(RegionName);
  if I < 0 then begin
    if not FRegionsPrepared then begin
      DoPrepareRegions;
      FRegionsPrepared := True
    end;

    Hint := 0;
    S := DoPrepareRegion(RegionName, Hint);
    FRegions.Values[RegionName] := S;
    I := FRegions.IndexOfName(RegionName);
    if I >= 0 then
      FRegions.Objects[I] := TObject(Hint);
    Result := DoCreateRegion(S, Hint)
  end else begin
    Hint := Integer(FRegions.Objects[I]);
    Result := DoCreateRegion(FRegions.Values[RegionName], Hint)
  end
end;

procedure TMyskaStore.BeginUpdate;
begin
  if FUpdateCount = 0 then begin
    Connected := True;
    DoBeginUpdate
  end;
  Inc(FUpdateCount)
end;

procedure TMyskaStore.EndUpdate;
begin
  Dec(FUpdateCount);
  if FUpdateCount = 0 then
    DoEndUpdate
end;

procedure TMyskaStore.DoConnect;
begin
end;

procedure TMyskaStore.DoDisconnect;
begin
end;

function TMyskaStore.DoPrepareGenerator(const GeneratorName: string): string;
begin
  Result := UpperCase(GeneratorName)
end;

procedure TMyskaStore.DoParseSQL(const Query: string; Statements: TStrings);
begin
  Statements.Clear;
  if Trim(Query) <> '' then
    Statements.Add(Query)
end;

function TMyskaStore.DoExec(const Query: string; Options: TSelectOptions): TDataSet;
begin
  Result := nil
end;

procedure TMyskaStore.DoPrepareGenerators;
begin
end;

function TMyskaStore.DoLock(const LockName: string): TObject;
begin
  Result := nil
end;

procedure TMyskaStore.DoPrepareLocks;
begin
end;

procedure TMyskaStore.DoPrepareApps;
begin
end;

procedure TMyskaStore.DoPrepareSessions;
begin
end;

procedure TMyskaStore.DoPrepareRegions;
begin
end;

function TMyskaStore.DoPrepareRegion(const RegionName: string; var Hint: Integer): string;
begin
  Result := UpperCase(RegionName)
end;

procedure TMyskaStore.DoOpenSession(const AppID: string; UserID: Cardinal);
begin
end;

procedure TMyskaStore.DoCloseSession(const AppID: string);
begin
end;

procedure TMyskaStore.DoAuthenticateSession(UserID: Cardinal);
begin
end;

procedure TMyskaStore.DoLoadUsers;
begin
end;

procedure TMyskaStore.DoModifyUser(User: TMyskaUser; IsNew: Boolean);
begin
end;

procedure TMyskaStore.DoCleanUp;
begin
end;

procedure TMyskaStore.DoAdd(Sender: TMyskaApp);
begin
  with Sender.FDBQueries do begin
    Values['app.id'] := Sender.AppID;
  end;
end;

procedure TMyskaStore.DoRemove(Sender: TMyskaApp);
begin
end;

function TMyskaStore.ExclusiveAccess: Boolean;
begin
  Result := False
end;

procedure TMyskaStore.ConfigureQueries;
begin
end;

procedure TMyskaStore.DoPreparePropertyBlobs;
begin
end;

procedure TMyskaStore.DoLoadPropertyBlob(const ID: string; Stream: TStream);
begin
end;

procedure TMyskaStore.DoSavePropertyBlob(const ID: string; Stream: TStream);
begin
end;

procedure TMyskaStore.DoBeginUpdate;
begin
end;

procedure TMyskaStore.DoEndUpdate;
begin
end;

class function TMyskaStore.ValidFile(const Header: string): Boolean;
begin
  Result := False
end;

//--------------------------------------------------------------------------

procedure TMyskaApp.Check(Condition: Boolean; const Msg: string);
begin
  uMyskaDB.Check(Condition, Self, Msg)
end;

procedure TMyskaApp.Check(Condition: Boolean; const Fmt: string; const Args: array of const);
begin
  if not Condition then
    uMyskaDB.Check(Condition, Self, Format(Fmt, Args));
end;

procedure TMyskaApp.SetStore(Value: TMyskaStore);
begin
  if FStore <> Value then begin
    Connected := False;
    FStore := Value;
  end
end;

procedure TMyskaApp.SetAppID(const Value: string);
begin
  if not SameText(FAppID, Value) then begin
    Connected := False;
    FAppID := UpperCase(Value)
  end
end;

function TMyskaApp.Lock(const LockName: string): TObject;
begin
  Connected := True;
  Result := Store.Lock(AppID + '.' + LockName)
end;

function TMyskaApp.CreateRegion(const RegionName: string): TMyskaRegion;
begin
  Connected := True;
  Result := Store.CreateRegion(AppID + '.' + RegionName)
end;

function TMyskaApp.GenID(const GeneratorName: string): Cardinal;
begin
  Connected := True;
  if Pos(ContextSeparator, GeneratorName) <> 0 then
    Result := Store.GenID(GeneratorName)
  else
    Result := Store.GenID(AppID + '.' + GeneratorName)
end;

procedure TMyskaApp.ResetGenID(const GeneratorName: string);
begin
  Connected := True;
  Store.ResetGenID(AppID + '.' + GeneratorName);
end;

function TMyskaApp.Exec(const Query: string; Options: TSelectOptions; const Args: array of const): TDataSet;
begin
  Connected := True;
  Store.Params.Add(Params);
  try
    Result := Store.Exec(Query, Options, Args, Params)
  finally
    Store.Params.Remove(Params)
  end
end;

function TMyskaApp.Exec(const Query: string; Options: TSelectOptions): TDataSet;
begin
  Result := Exec(Query, Options, [])
end;

procedure TMyskaApp.ExecScript(Stream: TStream);
begin
  Connected := True;
  Store.Params.Add(Params);
  try
    Store.ExecScript(Stream, Params);
  finally
    Store.Params.Remove(Params);
  end
end;

procedure TMyskaApp.ExecScript(const ScriptFileName: string);
begin
  Connected := True;
  Store.Params.Add(Params);
  try
    Store.ExecScript(ScriptFileName, Params);
  finally
    Store.Params.Remove(Params);
  end
end;

function TMyskaApp.GetScript(const ID: string): string;
begin
  Result := ''
end;

function TMyskaApp.Select(const Query: string): Variant;
begin
  Result := Select(Query, [], Unassigned)
end;

function TMyskaApp.Select(const Query: string; const DefaultValue: Variant): Variant;
begin
  Result := Select(Query, [], DefaultValue)
end;

function TMyskaApp.Select(const Query: string; const Args: array of const; const DefaultValue: Variant): Variant;
begin
  Connected := True;
  Store.Params.Add(Params);
  try
    Result := Store.Select(Query, Args, DefaultValue)
  finally
    Store.Params.Remove(Params);
  end
end;

function TMyskaApp.Select(const Query: string; const Args: array of const): Variant;
begin
  Result := Select(Query, Args, Unassigned)
end;

function TMyskaApp.Exists(const Query: string): Boolean;
begin
  Result := Exists(Query, [])
end;

function TMyskaApp.Exists(const Query: string; const Args: array of const): Boolean;
begin
  Connected := True;
  Store.Params.Add(Params);
  try
    Result := Store.Exists(Query, Args)
  finally
    Store.Params.Remove(Params);
  end
end;

procedure TMyskaApp.Connect;
begin
  Check(Assigned(Store) and (AppID <> ''));

  FDBQueries := TPropSet.Create(nil);
  Params.Add(FDBQueries);
  try
    Store.Add(Self);
    try
      DoConnect;
      ConfigureQueries;
    except
      Store.Remove(Self);
      raise
    end
  except
    FreeAndNil(FDBQueries);
    raise
  end
end;

procedure TMyskaApp.DoConnect;
begin
end;

function TMyskaApp.Subst(const Text: string): string;
begin
  Result := Subst(Text, [])
end;

function TMyskaApp.Subst(const Text: string; const Args: array of const): string;
begin
  Connected := True;
  Store.Params.Add(Params);
  try
    Result := Store.Subst(Text, Args)
  finally
    Store.Params.Remove(Params);
  end
end;

procedure TMyskaApp.Disconnect;
begin
  try
    DoDisconnect
  finally
    Store.Remove(Self);
    FreeAndNil(FDBQueries)
  end
end;

procedure TMyskaApp.DoDisconnect;
begin
end;

procedure TMyskaApp.Upgrade(FromVersion: Integer; ToVersion: Integer);
var
  Ver: Integer;
begin
  while FromVersion <> ToVersion do begin
    Check(FromVersion < ToVersion);
    Ver := DoUpgrade(FromVersion);
    Check(Ver > FromVersion);
    FromVersion := Ver
  end
end;

procedure TMyskaApp.DoInstall;
begin
  Upgrade(-1, AppVersion)
end;

function TMyskaApp.DoUpgrade(OldVersion: Integer): Integer;
begin
  Result := OldVersion
end;

procedure TMyskaApp.ConfigureQueries;
begin
end;

procedure TMyskaApp.SetConnected(Value: Boolean);
begin
  if FConnected <> Value then
    if Value then begin
      FConnected := True;
      try
        Connect;
      except
        FConnected := False;
        raise
      end
    end else begin
      Disconnect;
      FConnected := False
    end
end;

constructor TMyskaApp.Create(AnOwner: TComponent);
begin
  FParams := TMyskaPropSet.Create(nil);
  inherited Create(AnOwner)
end;

destructor TMyskaApp.Destroy;
begin
  Connected := False;
  FreeAndNil(FParams);
  inherited;
end;

function TMyskaApp.GetUsers: TMyskaUsers;
begin
  Connected := True;
  Result := Store.Users
end;

procedure TMyskaApp.BeginUpdate;
begin
  Store.BeginUpdate
end;

procedure TMyskaApp.EndUpdate;
begin
  Store.EndUpdate
end;

//--------------------------------------------------------------------------

procedure TMyskaSession.SetApp(Value: TMyskaApp);
begin
  if FApp <> Value then begin
    Connected := False;
    FApp := Value;
  end
end;

procedure TMyskaSession.SetStore(Value: TMyskaStore);
begin
  if FStore <> Value then begin
    Connected := False;
    FStore := Value
  end
end;

procedure TMyskaSession.SetUserName(const Value: string);
begin
  if FUserName <> Value then begin
    Connected := False;
    FUserName := Value
  end
end;

procedure TMyskaSession.SetConnected(Value: Boolean);
begin
  if FConnected <> Value then
    if Value then begin
      DoConnect;
      FConnected := True
    end else begin
      DoDisconnect;
      FConnected := False
    end
end;

procedure TMyskaSession.Check(Condition: Boolean; const Msg: string);
begin
  uMyskaDB.Check(Condition, Self, Msg);
end;

procedure TMyskaSession.DoConnect;
begin
  Check(Assigned(App) and Assigned(Store));
  App.Store := Store;
  App.Connected := True
end;

procedure TMyskaSession.DoDisconnect;
begin
  App.Connected := False
end;

//----------------------------------------------------------------------------

function FieldDefinition(const Name: string; DataType: TFieldType; Size: Integer): TFieldDefinition;
begin
  Result.Name := Name;
  Result.DataType := DataType;
  Result.Size := Size
end;

//----------------------------------------------------------------------------

var
  Factories: array of TMyskaStoreFactory;
  FactoryFileTypes: array of string;

function CreateStore(AnOwner: TComponent; const Connection: string; const FileTypeAliases: string): TMyskaStore;
var
  FileType: string;
  I: Integer;
  FileTypes: TStrings;
  Header: string;

  function ReadFileBytes(const FileName: string; Count: Integer): string;
  var
    Stream: TStream;
  begin
    try
      Stream := TFileStream.Create(FileName, fmOpenRead or fmShareDenyNone);
      try
        SetLength(Result, Count);
        SetLength(Result, Stream.Read(Result[1], Count))
      finally
        Stream.Free
      end
    except
      Result := ''
    end
  end;

begin
  FileType := Copy(ExtractFileExt(Connection), 2, MaxInt);

  FileTypes := TStringList.Create;
  try
    FileTypes.CommaText := FileTypeAliases;
    if FileTypes.IndexOfName(FileType) >= 0 then
      FileType := FileTypes.Values[FileType];

    for I := 0 to Length(Factories) - 1 do begin
      FileTypes.CommaText := FactoryFileTypes[I];
      if FileTypes.IndexOf(FileType) >= 0 then begin
        Result := Factories[I].Create(AnOwner);
        Result.Connection := Connection;
        exit
      end
    end
  finally
    FileTypes.Free
  end;

  // nenasli sme nic presne, zkusime detekovat format souboru
  Header := ReadFileBytes(Connection, 256);
  for I := 0 to Length(Factories) - 1 do begin
    if Factories[I].ValidFile(Header) then begin
      Result := Factories[I].Create(AnOwner);
      Result.Connection := Connection;
      exit
    end
  end;

  // pruser: neco vratime ale fungovat to nebude
  Result := TMyskaStore.Create(AnOwner);
  Result.Connection := Connection
end;

procedure RegisterFactory(Factory: TMyskaStoreFactory; const FileTypes: array of string);
var
  N: Integer;
  I: Integer;
  S: string;
begin
  N := Length(Factories);
  SetLength(Factories, N + 1);
  Factories[N] := Factory;
  SetLength(FactoryFileTypes, N + 1);

  S := '';
  for I := Low(FileTypes) to High(FileTypes) do begin
    if S <> '' then
      S := S + ',';
    S := S + Trim(FileTypes[I])
  end;
  FactoryFileTypes[N] := S
end;

begin
  SetLength(Factories, 0);
  SetLength(FactoryFileTypes, 0);
end.
