{ VERSION: 1.1 }
unit uSISFiles;

interface
uses
  Classes;

function ShellFolder(const ID: string; const DefaultValue: string = ''): string;
function DataPath(const ID: string; const Path: string): string;
function ConfigPath(const AppID: string = ''): string;
function CommonConfigPath(const AppID: string = ''): string;

procedure GetFiles(Files: TStrings; const Folder: string; const Mask: string = '*.*');

implementation
uses
  RegStr, RegUtils, SysUtils;

function ShellFolder(const ID: string; const DefaultValue: string = ''): string;
begin
  Result := RegReadString(
    'HKCU\' + REGSTR_PATH_EXPLORER + '\Shell Folders\' + ID,
    RegReadString('HKLM\' + REGSTR_PATH_EXPLORER + '\Shell Folders\' + ID, DefaultValue))
end;

function DataPath(const ID: string; const Path: string): string;
var
  Folder: string;
begin
  Folder := ShellFolder(ID, ExtractFilePath(ParamStr(0)) { TODO: ?!!!! });
  Folder := Folder + '\' + Path;
  ForceDirectories(Folder);
  Result := Folder + '\'
end;

function ConfigPath(const AppID: string): string;
var
  Folder: string;
begin
  Folder := 'SIS Spektrum';   // TUNE: Company
  if AppID <> '' then
    Folder := Folder + '\' + AppID;
  Result := DataPath('Local AppData', Folder);
end;

function CommonConfigPath(const AppID: string): string;
var
  Folder: string;
begin
  Folder := 'SIS Spektrum';   // TUNE: Company
  if AppID <> '' then
    Folder := Folder + '\' + AppID;
  Result := DataPath('Common AppData', Folder);
end;

procedure GetFiles(Files: TStrings; const Folder: string; const Mask: string);
var
  Path: string;
  Search: TSearchRec;
  S: string;
begin
  Path := ExpandFileName(Folder);
  if (Path <> '') and (Path[Length(Path)] <> '\') then
    Path := Path + '\';
  if DirectoryExists(ExtractFileDir(Path)) then begin
    if FindFirst(Path + Mask, faAnyFile,Search) = 0 then begin
      repeat
        if (Search.Attr and faHidden) = 0 then begin
          if (Search.Attr and faDirectory) = 0 then begin
            S := Path + Search.Name;
            if Files.IndexOf(S) < 0 then
              Files.Add(S);
          end
        end
      until FindNext(Search) <> 0;
      FindClose(Search);
    end;
  end
end;

end.
